From a62cca2268582a42c9895428f71df5310ad6ad2a Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: May 08 2020 06:20:06 +0000
Subject: [PATCH 569/2232] Add a use of type alias to test suite


---

diff --git a/tests/ffi/build.rs b/tests/ffi/build.rs
index b970362..2c96d73 100644
--- a/tests/ffi/build.rs
+++ b/tests/ffi/build.rs
@@ -3,7 +3,8 @@ fn main() {
         return;
     }
 
-    cxx_build::bridge("lib.rs")
+    let sources = vec!["lib.rs", "module.rs"];
+    cxx_build::bridges(sources)
         .file("tests.cc")
         .flag("-std=c++11")
         .compile("cxx-test-suite");
diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index e298e88..9457229 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -4,6 +4,8 @@
     clippy::trivially_copy_pass_by_ref
 )]
 
+pub mod module;
+
 use cxx::{CxxString, UniquePtr};
 use std::fmt::{self, Display};
 
@@ -47,7 +49,6 @@ pub mod ffi {
         fn c_take_primitive(n: usize);
         fn c_take_shared(shared: Shared);
         fn c_take_box(r: Box<R>);
-        fn c_take_unique_ptr(c: UniquePtr<C>);
         fn c_take_ref_r(r: &R);
         fn c_take_ref_c(c: &C);
         fn c_take_str(s: &str);
diff --git a/tests/ffi/module.rs b/tests/ffi/module.rs
new file mode 100644
index 0000000..77bae06
--- /dev/null
+++ b/tests/ffi/module.rs
@@ -0,0 +1,13 @@
+// Rustfmt mangles the extern type alias.
+// https://github.com/rust-lang/rustfmt/issues/4159
+#[rustfmt::skip]
+#[cxx::bridge(namespace = tests)]
+pub mod ffi {
+    extern "C" {
+        include!("tests/ffi/tests.h");
+
+        type C = crate::ffi::C;
+
+        fn c_take_unique_ptr(c: UniquePtr<C>);
+    }
+}
diff --git a/tests/test.rs b/tests/test.rs
index b8593c5..ddf8f70 100644
--- a/tests/test.rs
+++ b/tests/test.rs
@@ -89,7 +89,7 @@ fn test_c_take() {
     check!(ffi::c_take_shared(ffi::Shared { z: 2020 }));
     check!(ffi::c_take_box(Box::new(2020)));
     check!(ffi::c_take_ref_c(&unique_ptr));
-    check!(ffi::c_take_unique_ptr(unique_ptr));
+    check!(cxx_test_suite::module::ffi::c_take_unique_ptr(unique_ptr));
     check!(ffi::c_take_str("2020"));
     check!(ffi::c_take_sliceu8(b"2020"));
     check!(ffi::c_take_rust_string("2020".to_owned()));

